require("./bin/09_misc_function")

-- start main()
print( "current time = " .. os.date())
-- print( "current dir  = " .. lfs.currentdir() )


-- download wget,sha256
local fname = "./bin/00prepare.txt"
local t_dlist = readtext(fname)


-- cleaning temporary files
print( "cleaning temporary files ..." )
str = "rmdir /S /Q YogurtingJP"
os.execute(str)
str = "rmdir /S /Q temp"
os.execute(str)

--print(check_64bit())
--os.execute("pause")

for k,v in pairs(t_dlist) do
  wgetmodoki(v)
end


-- extract wget,sha256
local dir_unpack_base = "./temp"
for k,v in pairs(t_dlist) do
  line2extract(v,dir_unpack_base)
end

-- check SHA256 about wget.exe , sha256.exe
for k,v in pairs(t_dlist) do
  local flag = check_sha256(v)
  if not flag then
    print("ERROR : wrong checksum")
    return false
  end
end


--os.execute("pause")

-- download Clients
local fname = "./bin/02download_files.txt"
local t_dlist = readtext(fname)
for k,v in pairs(t_dlist) do
  wget(v)
end

-- check SHA256 about Clients
for k,v in pairs(t_dlist) do
  local flag = check_sha256(v)
  if not flag then
    print("ERROR : wrong checksum")
    return false
  end
end

-- os.exit()

-- make Yogurting folder
mkdir("YogurtingJP/ScreenShot")
mkdir("YogurtingJP/Models")
mkdir("YogurtingJP/Miles")

-- unpack tools
local dir_unpack_base = "./temp"
for k,v in pairs(t_dlist) do
  line2extract(v,dir_unpack_base)
end

-- unpack ELEVAT~1.EXE
str = ".\\bin\\7za920\\7z.exe x -o.\\YogurtingJP \".\\temp\\Elevation\\ELEVAT~1.EXE\""
os.execute(str)

str = "copy .\\bin\\elevate.cmd .\\YogurtingJP\\Elevation"
os.execute(str)

-- copy UAC check script
str = "copy .\\bin\\Elevation\\*.* .\\YogurtingJP\\Elevation"
os.execute(str)
-- run  UAC check script
str = "cd .\\YogurtingJP && .\\Elevation\\uac_check.vbs && cd .."
os.execute(str)


--unpack InstallShield
cmd_IsXunpack = ".\\temp\\uniextract\\bin\\IsXunpack.exe"
cmd_unpack_exe = cmd_IsXunpack.." download_files\\yg_setup_20070712.exe < .\\bin\\03hit_enter.txt"
os.execute(cmd_unpack_exe)

cmd_move1 = "move download_files\\Disk1 temp"
os.execute(cmd_move1)

cmd_uniextract = ".\\temp\\uniextract\\UniExtract.exe"
cmd_unpack_cab = cmd_uniextract.." temp/Disk1/data1.cab ../../YogurtingJP"
os.execute(cmd_unpack_cab)


-- copy  Lyna tools
str = "copy .\\temp\\Yogurting.exe .\\YogurtingJP"
os.execute(str)
str = "copy .\\temp\\winyg\\winyg.exe .\\YogurtingJP"
os.execute(str)
str = "copy .\\temp\\winyg\\winyg.dll .\\YogurtingJP"
os.execute(str)
str = "copy .\\temp\\winyg\\YgAddr.ini .\\YogurtingJP"
os.execute(str)
str = "copy .\\temp\\winyg\\readme.txt .\\YogurtingJP\\winyg_readme.txt"
os.execute(str)

-- copy Lua script
str = "copy .\\bin\\lua.exe .\\YogurtingJP"
os.execute(str)
str = "copy .\\bin\\lua_setup_reg.lua .\\YogurtingJP"
os.execute(str)

-- copy AppLocale
--str = "copy .\\temp\\SBAppLocale\\SBAppLocale.exe .\\YogurtingJP"
--os.execute(str)
--str = "copy .\\temp\\SBAppLocale\\ReadMe_ENG.html .\\YogurtingJP\\SBAppLocale.html"
--os.execute(str)


-- move Yogurting folder
t_Models = {"Avatar","CLT","Env","Font","Item","MadStone","Monster","Movie","NPC","Skill","Sound","Terrain","UI","Yoting.yiv"}
t_Miles  = {"mssds3d.m3d","mssdsp.flt","msseax.m3d","mssmp3.asi","msssoft.m3d"}
for k,v in pairs(t_Models) do
  str = "move YogurtingJP\\"..v.." YogurtingJP\\Models"
  os.execute(str)
end
for k,v in pairs(t_Miles) do
  str = "move YogurtingJP\\"..v.." YogurtingJP\\Miles"
  os.execute(str)
end





-- backup Registry
str = "reg export HKEY_CURRENT_USER\\Software\\NTIXSoft YogurtingJP\\yg_reg_backup.reg"
os.execute(str)

-- make Registry
fname_reg = "YogurtingJP\\yg_reg_JP.reg"
f = io.open(fname_reg, "w")
  --Windows Registry Editor Version 5.00
  --
  --[HKEY_CURRENT_USER\Software\NTIXSoft]
  --
  --[HKEY_CURRENT_USER\Software\NTIXSoft\Yogurting]
  --"AutoStart"="0"
  --"InstallPath"="J:\\ProgramFiles\\Yogurting"
  --"MajorVersion"="0"
  --"MinorVersion"="0"
  --"Version"="0.01"
  --
  --[HKEY_CURRENT_USER\Software\NTIXSoft\Yogurting\Patcher]
  --"Install Version"=dword:77930142
  --"VERSION"=dword:00005ccd
  f:write("Windows Registry Editor Version 5.00\n")
  f:write("\n")
  f:write("[HKEY_CURRENT_USER\\Software\\NTIXSoft]\n")
  f:write("\n")
  f:write("[HKEY_CURRENT_USER\\Software\\NTIXSoft\\Yogurting]\n")
  f:write("\"AutoStart\"=\"0\"\n")
  str_path = string.gsub(arg[1],"\\","\\\\")
  str      = "\"InstallPath\"=\""..str_path.."YogurtingJP\""
  f:write(str.."\n")
  f:write("\"MajorVersion\"=\"0\"\n")
  f:write("\"MinorVersion\"=\"0\"\n")
  f:write("\"Version\"=\"0.01\"\n")
  f:write("\n")
  f:write("[HKEY_CURRENT_USER\\Software\\NTIXSoft\\Yogurting\\Patcher]\n")
  f:write("\"Install Version\"=dword:77930142\n")
  f:write("\"VERSION\"=dword:00005ccd\n")
f:close()

-- import Registry
str = "reg import "..fname_reg
os.execute(str)

-- make winyg.ini
f = io.open("YogurtingJP\\winyg.ini", "w")
--[Form]
--X=0
--Y=0
--[Settings]
--ExePath=J:\ProgramFiles\Yogurting\_L.exe
--Param=D20CA13E-2F80-408d-85DF-ED1C36F3CF1F
--UseWindow=1
--WindowSize=1
--WindowPosX=0
--WindowPosY=0
--UseTitleInfo=0
--SkipLogo=1
--UseInputID=0
--IDList=""
--[IPList]
--Addr=quartet.dip.jp
--Selected=1
  f:write("[Form]\n")
  f:write("X=0\n")
  f:write("Y=0\n")
  f:write("[Settings]\n")
  str = "ExePath="..arg[1].."YogurtingJP\\_L.exe"
  f:write(str.."\n")
  f:write("Param=D20CA13E-2F80-408d-85DF-ED1C36F3CF1F\n")
  f:write("UseWindow=1\n")
  f:write("WindowSize=1\n")
  f:write("WindowPosX=0\n")
  f:write("WindowPosY=0\n")
  f:write("UseTitleInfo=1\n")
  f:write("SkipLogo=1\n")
  f:write("UseInputID=0\n")
  f:write("IDList=\"\"\n")
  f:write("[IPList]\n")
  f:write("Addr=quartet.dip.jp\n")
  f:write("Selected=1\n")
f:close()

-- cleaning temporary files
print( "cleaning temporary files ..." )
str = "rmdir /S /Q temp"
os.execute(str)

