
--e֐ŗp萔 R}ḧʒufBNg
function static_value()
  t_cmd = {}
  t_cmd["dir_download_base"]  = "./download_files/"
  t_cmd["dir_package"]        = "./build_scripts"
  t_cmd["dir_build_temp"]     = "../system/temp"
  
  t_cmd["cmd_wgetmodoki"] = "cscript.exe .\\bin\\wgetmodoki.wsf"
  t_cmd["cmdopt2"]   = " -t 3 -T 30 -N --max-redirect 0 -P "
  
  t_cmd["cmd_wget"]       = ".\\temp\\wget.exe"
  t_cmd["cmdopt"]    = " -t 3 -T 30 -N --no-check-certificate --max-redirect 3 -O "
  
  t_cmd["cmd_sha256"]  = ".\\temp\\bin\\sha256sum.exe "
  t_cmd["cmd_7za"]     = ".\\bin\\7za920\\7z.exe"
  t_cmd["cmd_extract"] = ".\\bin\\extract.bat"
  t_cmd["fname_temp"]  = ".\\temp\\__temp__.txt"
  t_cmd["fname_temp2"] = "./temp/__temp__.txt"
  t_cmd["check_bat"]   = ".\\setup_scripts\\02_check_64bit.bat"
  return t_cmd
end

-- z̓e\ fobOp
function print_table(t)
  for k,v in pairs(t) do
      print(k..' : "'..v..'"')
  end
end

-- http://d.hatena.ne.jp/eiji8pou/20090901/1251811694
-- Pure LuaŃt@C̑݁E񑶍݂𒲂ׂ
function fileexist(str)
  if type(str) ~= "string" then return false end -- ^󂯕tȂB
  if str:len() == 0 then return false end -- 󕶎̏B
  local fh = io.open(str,"r") -- Ƃ肠̕t@CƂĊJB
  if fh then
    io.close(fh) -- ڂÎŕB
    return true  -- ^ԂB
  end
  return false
end

-- eLXgt@Cǂݍ #ł͂܂RgsƁAs
function readtext(fname)
  local t_dlist={}
  io.input(fname)
  for line in io.lines() do
    if string.sub(line,1,1)~="#" and line~="" then
      table.insert(t_dlist,line)
    end
  end
  io.close()
  io.input()
  -- print_table(t_dlist)
  return t_dlist
end

function mkdir(dirname)
  local cmd2_mkdir      = "if not exist "..dirname.." mkdir "..dirname
  local cmd3_mkdir = string.gsub(cmd2_mkdir,"/","\\")
  -- print(cmd3_mkdir)
  os.execute(cmd3_mkdir)
end

function wgetmodoki(line)
  local t={}
  string.gsub(line,"(%S+)", function (v) table.insert(t,v) end)
  
  t_cmd = static_value()
  local cmd_wgetmodoki  = t_cmd["cmd_wgetmodoki"]
  local cmdopt          = t_cmd["cmdopt2"]
  local dir_download    = t_cmd["dir_download_base"]..t[2]
  
  local url             = t[1]
  local fname_download  = dir_download.."/"..t[3]
  local cmd2_wgetmodoki = cmd_wgetmodoki.." "..url.." "..cmdopt.." "..dir_download
  
  if fileexist(fname_download) then
    return
  end
  
  mkdir(dir_download)
  os.execute(cmd2_wgetmodoki)
end

function line2extract(line,dir_unpack_base)
  local t={}
  string.gsub(line,"(%S+)", function (v) table.insert(t,v) end)
  
  local url = t[1]
  t_cmd = static_value()
  local cmd_7za        = t_cmd["cmd_7za"]
  local cmd_extract    = t_cmd["cmd_extract"]
  local dir_download   = t_cmd["dir_download_base"]..t[2]
  local fname_download = dir_download.."/"..t[3]
  local dir_unpack = dir_unpack_base.."/"..t[4]
  -- local cmd2_unpack = cmd_7za.." x -y "..fname_download.." -o"..dir_unpack
  local cmd2_unpack = cmd_extract.." "..fname_download.." "..dir_unpack
  
  if t[4]=="none" then return   end
  
  mkdir(dir_unpack)
  --print(cmd2_unpack)
  os.execute(cmd2_unpack)
end

function extract(fname,dir_unpack)
  t_cmd = static_value()
  local cmd_extract    = t_cmd["cmd_extract"]
  local cmd2_unpack = cmd_extract.." "..fname.." "..dir_unpack
  
  mkdir(dir_unpack)
  os.execute(cmd2_unpack)
end


function sha256sum(filename)
  t_cmd = static_value()
  local fname_temp     = t_cmd["fname_temp2"]
  local cmd_sha256     = t_cmd["cmd_sha256"]
  
  local cmd2_sha256 = cmd_sha256..filename.." > "..fname_temp
  
  os.execute(cmd2_sha256)
  
  fh = io.input(fname_temp)
  local line_sha256a = io.read()
  io.close(fh)
  os.remove(fname_temp)
  local t2={}
  string.gsub(line_sha256a,"(%S+)", function (v) table.insert(t2,v) end)
  local sha256a = t2[1]
  
  return sha256a
end

function check_sha256(line)
  local t={}
  string.gsub(line,"(%S+)", function (v) table.insert(t,v) end)
  
  t_cmd = static_value()
  local fname_temp     = t_cmd["fname_temp2"]
  local cmd_sha256     = t_cmd["cmd_sha256"]
  local dir_download   = t_cmd["dir_download_base"]..t[2]
  local fname_download = dir_download.."/"..t[3]
  local sha256b = t[5]
  
  local cmd2_sha256 = cmd_sha256..fname_download.." > "..fname_temp
  -- print(sha256b)
  
  if sha256b==nil then
    print("ERROR : no sha256 checksum parameter")
    return false
  end
  
  if string.len(sha256b)~=64 then
    print("ERROR : wrong sha256 checksum parameter")
    return false
  end
  
    print("checking .. "..t[3])
  os.execute(cmd2_sha256)
  
  fh = io.input(fname_temp)
  local line_sha256a = io.read()
  io.close(fh)
  os.remove(fname_temp)
  local t2={}
  string.gsub(line_sha256a,"(%S+)", function (v) table.insert(t2,v) end)
  local sha256a = t2[1]
  --print(sha256a)
  
  if sha256a==sha256b then
    print("SHA256 OK : "..t[3])
    -- os.execute("pause")
    return true
  end
  
  print("ERROR : wrong checksum(SHA256) "..fname_download)
  print("        please try again...")
  -- os.remove(fname_download)
  return false
end

function wget(line)
  local t={}
  string.gsub(line,"(%S+)", function (v) table.insert(t,v) end)
  
  local url = t[1]
  t_cmd = static_value()
  local cmd_wget       = t_cmd["cmd_wget"]
  local dir_download   = t_cmd["dir_download_base"]..t[2]
  local cmdopt         = t_cmd["cmdopt"]
  
  local fname_download = dir_download.."/"..t[3]
  local cmd2_wget = cmd_wget.." "..url.." "..cmdopt.." "..fname_download
  
  if fileexist(fname_download) then
    return false
  end
  
  mkdir(dir_download)
  os.execute(cmd2_wget)
  return true
end

function check_64bit()
  t_cmd = static_value()
  local check_bat   = t_cmd["check_bat"]
  local fname_temp  = t_cmd["fname_temp"]
  local fname_temp2 = t_cmd["fname_temp2"]
  local cmd2_check  = check_bat.." "..fname_temp
  
  os.execute(cmd2_check)
  
  flag = fileexist(fname_temp2)
  if flag then
    -- print("64bit!!")
    os.remove(fname_temp)
    return true
  end
  
  return false
end


-- pbP[W̕ϐǍ
function getPackageValue(name_in)
  files={}
  depends={}
  sh32=""
  sh64=""
  sh_common=""
  check_install=""
  sample=""
  local t = {}

  t_cmd = static_value()
  local dir_package   = t_cmd["dir_package"]
  
  fname = dir_package.."/"..name_in..".lua"
  if not fileexist(fname) then
    print("error - cannot find package  "..name_in)
    return t
  end
  
  require(dir_package.."/"..name_in)

  t["name"]      = name_in
  t["version"]   = version
  t["files"]     = files
  t["depends"]   = depends
  t["check_install"] = check_install

  t["sh_common"] = sh_common
  t["sh32"]    = sh32
  if sh64=="" then
    t["sh64"]  = sh32
  else
    t["sh64"]  = sh64
  end

  t["sample"] = sample

  return t
end

function getPackageValues(names_in)
  ts = {}
  for k,v in pairs(names_in) do
    t = getPackageValue(v)
    if (t["name"] ~= nil ) then
      table.insert(ts,t)
    end
  end
  return ts
end

-- e[u̐擪ɗvfǉ
-- ߂lfalse : vfłɑ݁Avf擪Ɉړ
-- ߂ltrue  : VKvf擪ɒǋL
function table_insert_top_move(t,value)
  local flag_del = true
  delpos = 0
  for k,v in pairs(t) do
    if v==value then
      flag_del = false
      delpos = k
    end
  end
  
  table.insert(t, 1, value)
  if not flag_del then
    table.remove(t,delpos+1)
  end
  
  return flag_del
end

-- e[u̖ɗvfǉ
-- vfłɑ݂ĂAǉEړfalseԂ
function table_insert_top(t,value)
  local flag_insert = true
  for k,v in pairs(t) do
    if v==value then
      flag_insert = false
      break
    end
  end
  
  if flag_insert then
    table.insert(t, 1, value)
  end
  
  return flag_insert
end

-- e[u̖ɗvfǉ łɗvf݂ĂfalseԂ
function table_insert_bottom(t,value)
  local flag_insert = true
  for k,v in pairs(t) do
    if v==value then
      flag_insert = false
      break
    end
  end
  
  if flag_insert then
    table.insert(t, value)
  end
  
  return flag_insert
end

-- e[uvf폜
function table_erase(t,value)
  local flag_erase = false
  delpos = 0
  for k,v in pairs(t) do
    if v==value then
      flag_erase = true
      delpos = k
      break
    end
  end
  
  if flag_erase then
    table.remove(t,delpos)
  end
  
  return flag_erase
end

-- e[uvf̈vJEg
function table_include_count(t_base,values)
  count = 0
  for k,v in pairs(values) do
    for k2,v2 in pairs(t_base) do
      -- print(v.." - "..v2)
      if v == v2 then
        count = count + 1
      end
    end
  end
  return count
end

-- ˑ֌W
function search_depend(fname_packagelist)
  add_package = readtext(fname_packagelist)
  package_names = {}
  package_names_temp = {}
  table_package = {}
  
  -- ߕspbP[WXg package_names_temp 쐬B̎_ŏԂ͂߂Ⴍ
  -- pbP[Wϐe[u table_package 쐬
  while true do
    add_package2 = {} -- [vŒǉpbP[W
    for k,v in pairs(add_package) do
      t={}
      flag1 = table_insert_bottom(package_names_temp,v)
      if flag1 then
        t = getPackageValue(v)
        table_package[v] = t
      else
        t = table_package[v]
      end
      
      for k2,v2 in pairs(t["depends"]) do
        flag2 = table_insert_top_move(package_names_temp,v2)
        if flag2 then -- vfǋLƂ
          table_insert_top(add_package2,v2)
          t = getPackageValue(v2)
          table_package[v2] = t
        end
      end
    end
    
    if #add_package2 == 0 then
      break
    end
    add_package = add_package2
  end
  
  -- QƐȂ package_names ֒ǉ
  while true do
    package_names_temp2 = {}
    
    for k,v in pairs(package_names_temp) do
      local t = table_package[v]
      count = table_include_count(package_names,t["depends"])
      num = #t["depends"] - count
      if num == 0 then
        table.insert(package_names, v)
      else
        table.insert(package_names_temp2, v)
      end
    end
    
    if #package_names_temp2 == 0 then
      break
    end
    package_names_temp = package_names_temp2
  end
  
  result_t = {}
  result_t["package_names"] = package_names
  result_t["table_package"] = table_package
  return result_t
end

function readHash(fname)
  t_result={}
  
  if fileexist(fname) then
    t_txt = readtext(fname)
    for k,line in pairs(t_txt) do
      local t={}
      string.gsub(line,"(%S+)", function (v) table.insert(t,v) end)
      t_result[t[1]]=t[2]
    end
  end
  
  return t_result
end

function saveHash(t,fname)
  fout = io.open(fname,"w")
  
  for k,v in pairs(t) do
    str = k.." "..v
    fout:write(str.."\n")
  end
  
  fout:close()
end

